# Chatbots

## 🔖 Outline

To be added


## 🗒️ Notebooks

Set of notebooks associated with the chapter. 

1. **[Intent Detection using CNN, RNN](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/01_CNN_RNN_ATIS_intents.ipynb)**: Here we demonstrate various CNN and RNN models for the task on Intent Detection on the ATIS dataset.

2. **[Intent Detection using BERT](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/02_BERT_ATIS.ipynb)**: Here we demonstrate how to use pytorch pre-trained BERT to classify the intent in the ATIS dataset. 

3. **[Intent Detection using BERT(Binary)](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/03_BERT_ATIS_Binary.ipynb)**: Here we reduce the intent classification task on the ATIS dataset into a binary classification task and then use pytorch pre-trained BERT to classify the intents.

4. **[Slot Filling using CRFs](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/04_CRF_SNIPS_slots.ipynb)**: Here we demonstrate using CRFs to perform the task of Slot filling on the SNIPS dataset.

5. **[Slot Filling using BERT](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/05_BERT_SNIPS.ipynb)**: Here we demonstrate using pytorch pre-trained BERT for the task of slot filling on the SNIPS dataset using the HuggingFace Transformers library.

6. **[Simple Chatbot using Chatfuel](https://github.com/practical-nlp/practical-nlp/blob/master/Ch6/06_chatfuelbot.ipynb)**: Here we demonstrate how to build a simple chatbot which does not have "intelligence" to order pizzas using chatfuel.


## 🖼️ Figures

Color figures as requested by the readers. 

![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-1.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-2.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-3.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-4.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-5.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-6.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-7.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-8.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-9.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-10.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-11.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-12.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-13.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-14.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-15.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-16.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-17.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-18.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-19.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-20.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-21.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-22.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-23.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-24.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-25.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-26.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-27.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/6-28.png)
