# Contributing

We strongly believe open sourcing projects for contributions is one of the best ways to improve the qulaity of the project. We are etternally thankful to our readers for pointing out typographical errors and bugs. If you’re a new open source contributor, the process can be intimidating. We want to make your contribution experience as smooth as possible.<br>

If you find a typographical error in the book text, kindly open a errata via this link:
[https://www.oreilly.com/catalog/errata.csp?isbn=0636920262329](https://www.oreilly.com/catalog/errata.csp?isbn=0636920262329)

If you find a bug in the code notebooks or want to add a new notebook we prefer that you open an issue in this repo. In the issue please provide us details about the bug such as notebook link, python version, error(including full traceback) and where your running the notebook(local or colab). You can find the ISSUES Template [here](https://github.com/practical-nlp/practical-nlp/tree/master/.github/ISSUE_TEMPLATE).
<br>

From here you can do one of two these two things:
1. Wait for us to fix the bug.
2. Fix the bug yourself and send a pull request.<br>
We highly encourage you to fix the bug yourself and send a pull request.

## Pull Request Process

1. Please open an issue first.
2. Fork the repository.
3. Clone the forked repository.
4. You can start working on making the necessary changes.
5. When your done, push the changes to your forked repository.
6. Head to the forked repository and click on a Compare & pull request button.
5. Add short yet descriptive and easy to understand descriptions for all the changes you make.
<br>
We will soon be adding a PULL REQUESTS Template.<br>

## Code of Conduct

### Our Pledge

In the interest of fostering an open and welcoming environment, we as
contributors and maintainers pledge to making participation in our project and
our community a harassment-free experience for everyone, regardless of age, body
size, disability, ethnicity, gender identity and expression, level of experience,
nationality, personal appearance, race, religion, or sexual identity and
orientation.

### Our Standards

Examples of behavior that contributes to creating a positive environment
include:

* Using welcoming and inclusive language
* Being respectful of differing viewpoints and experiences
* Gracefully accepting constructive criticism
* Focusing on what is best for the community
* Showing empathy towards other community members

Examples of unacceptable behavior by participants include:

* The use of sexualized language or imagery and unwelcome sexual attention or
advances
* Trolling, insulting/derogatory comments, and personal or political attacks
* Public or private harassment
* Publishing others' private information, such as a physical or electronic
  address, without explicit permission
* Other conduct which could reasonably be considered inappropriate in a
  professional setting

### Our Responsibilities

We are responsible for clarifying the standards of acceptable
behavior and are expected to take appropriate and fair corrective action in
response to any instances of unacceptable behavior.

We have the right and responsibility to remove, edit, or
reject comments, commits, code, wiki edits, issues, and other contributions
that are not aligned to this Code of Conduct, or to ban temporarily or
permanently any contributor for other behaviors that they deem inappropriate,
threatening, offensive, or harmful.


### Attribution

This Code of Conduct is adapted from the [Contributor Covenant homepage](http://contributor-covenant.org), [version 1.4](http://contributor-covenant.org/version/1/4/)
